!---------------------------------------------------------------------
! BRISCOLA.R : questo programma gioca a briscola contro l'operatore
!---------------------------------------------------------------------

PROGRAM BRISCOLA

! -------------------------
! dichiara array e funzioni
! -------------------------

!$RCODE="RANDOMIZE TIMER : KEY OFF"

DIM MAZZO%[39],PUNTICARTE%[9],CARTECOMPUTER[2],CARTEGIOCATORE[2],ASSO%[3],TRE%[3]

FUNCTION CASUALE(X)
    CASUALE=INT(RND(1)*X)
END FUNCTION

FUNCTION VALORE(X)
    VALORE=INT(MAZZO%[X]/4)
END FUNCTION

FUNCTION SEME(X)
    SEME=MAZZO%[X] AND 3
END FUNCTION

FUNCTION PRESA(X)
    PRESA=((SC=BRISCOLA)<(SP=BRISCOLA)) OR ((SP=BRISCOLA)=(SC=BRISCOLA)) AND ((SC=SP AND VC>VP) OR (SC<>SP AND TURNO=2))
END FUNCTION

!$INCLUDE="PC.LIB"

PROCEDURE SWAP(SW1,SW2->SW1,SW2)
    SWT=SW1
    SW1=SW2
    SW2=SWT
END PROCEDURE

PROCEDURE INTESTAZIONE
    CLS
    PRINT("   B R I S C O L A   by Claudio Larini  ")
END PROCEDURE

PROCEDURE MOSTRAPUNTI
    LOCATE(3,30)
    PRINT("Le carte sono finite")
    PRINT
    PRINT("I miei punti sono";PUNTICOMPUTER)
    PRINT("I tuoi punti sono";PUNTIGIOCATORE)
    LOCATE(8,1)
    IF PUNTICOMPUTER>PUNTIGIOCATORE THEN
        PRINT("VINCO IO !!!")
    END IF
    IF PUNTICOMPUTER=PUNTIGIOCATORE THEN
        PRINT("ABBIAMO PAREGGIATO")
    END IF
    IF PUNTICOMPUTER<PUNTIGIOCATORE THEN
        PRINT("HAI VINTO TU !!")
    END IF
END PROCEDURE

PROCEDURE DISEGNACARTA(N,RR,CC)
!-------------------------------
!disegna una carta sullo schermo
!-------------------------------
    V$=MID$("24567FCR3A",VALORE(N)+1,1)
    S$=MID$(CHR$(6)+CHR$(5)+CHR$(4)+CHR$(3),SEME(N)+1,1)
    C$="     "
    LOCATE(RR,CC)   PRINT("Ŀ")
    LOCATE(RR+1,CC) PRINT("";V$;"    ")
    LOCATE(RR+2,CC) PRINT("";S$;"    ")
    LOCATE(RR+3,CC) PRINT(C$)
    LOCATE(RR+4,CC) PRINT("  ";S$;"  ")
    LOCATE(RR+5,CC) PRINT(C$)
    LOCATE(RR+6,CC) PRINT("    ";S$;"")
    LOCATE(RR+7,CC) PRINT("    ";V$;"")
    LOCATE(RR+8,CC) PRINT("")
END PROCEDURE

PROCEDURE DISEGNAGIOCATA
! ------------------------------
! disegna la situazione in campo
! ------------------------------
    CLS
    FOR Q=0 TO D  ! disegna le carte del giocatore
      DISEGNACARTA(CARTEGIOCATORE[Q],13,28+4*Q)
    END FOR
    IF CARTEUSCITE<=38 THEN
      DISEGNACARTA(39,8,16)             ! disegna la carta seme
      LOCATE(11,15)
      PRINT("")                ! disegna il mazzo delle carte
      FOR Q=1 TO 7
        PRINT(TAB(15);"")
      END FOR
      PRINT(TAB(15);"")
    END IF
END PROCEDURE

PROCEDURE CARTACOMPUTER
    DISEGNACARTA(CARTECOMPUTER[GIOCATACOMPUTER],1,67-7*TURNO)
    SC=SEME(N)
    VC=VALORE(N)
END PROCEDURE

PROCEDURE CARTAGIOCATORE
    DISEGNACARTA(CARTEGIOCATORE[GIOCATAGIOCATORE],1,46+7*TURNO)
    SP=SEME(N)
    VP=VALORE(N)
END PROCEDURE

PROCEDURE SUBC
    SC=SEME(CARTECOMPUTER[GIOCATACOMPUTER])
    VC=VALORE(CARTECOMPUTER[GIOCATACOMPUTER])
END PROCEDURE

PROCEDURE SUBG
    SP=SEME(CARTEGIOCATORE[GIOCATAGIOCATORE])
    VP=VALORE(CARTEGIOCATORE[GIOCATAGIOCATORE])
END PROCEDURE

PROCEDURE TRECARTE
    LOCATE(1,1)
    PRINT("Tocca a te : scegli la carta 1, 2 o 3 ?")
    LOCATE(3,1)
    PRINT("Carte giocate ";CARTEUSCITE)
    IF CARTEUSCITE=40 THEN
        PRINT("I tuoi punti sono";PUNTIGIOCATORE)
    END IF
    V$=""
    WHILE V$<"1" OR V$>"3"
      GET(V$)
    END WHILE
    GIOCATAGIOCATORE=VAL(V$)-1
    CARTAGIOCATORE
END PROCEDURE

PROCEDURE DUECARTE
    LOCATE(1,1)
    PRINT("Tocca a te: scegli la carta 1 o 2 ?")
    LOCATE(3,1)
    PRINT("Carte giocate";CARTEUSCITE)
    PRINT("I tuoi punti sono";PUNTIGIOCATORE)
    V$=""
    WHILE V$<"1" OR V$>"2"
      GET(V$)
    END WHILE
    CARTAGIOCATORE
END PROCEDURE

PROCEDURE RISPONDECOMPUTER
    LOCATE(1,1)
    PRINT("Tocca a me : io gioco  ")
    F=(CARTEUSCITE=38)*(PUNTICARTE%[VALORE(39)]*106+3)-1.2
    E=-99
    FOR GIOCATACOMPUTER=0 TO 2
      SUBC
      J=-(1+2*PRESA(0))*(PUNTICARTE%[VP]+PUNTICARTE%[VC]+F)+3.4*(BRISCOLA=SC)
      IF PUNTICOMPUTER<=60 AND PRESA(0) AND PUNTICOMPUTER+PUNTICARTE%[VP]+PUNTICARTE%[VC]>60 THEN
             CARTACOMPUTER    ! introdurre boolean per uscita !!!
      END IF
      IF J>E THEN
             E=J
             I=GIOCATACOMPUTER
      END IF
    END FOR
    GIOCATACOMPUTER=I
    CARTACOMPUTER
END PROCEDURE

PROCEDURE GIOCACOMPUTER
    LOCATE(1,1)
    PRINT("Tocca a me : io gioco  ")
    E=99
    FOR GIOCATACOMPUTER=0 TO 2
      SC=SEME(CARTECOMPUTER[GIOCATACOMPUTER])
      VC=VALORE(CARTECOMPUTER[GIOCATACOMPUTER])
      F=(VC=8 AND ASSO%[SC]=0)*32
      J=11*(1-ASSO%[SC])+10*(1-TRE%[SC])
      J=J-6*(SC=BRISCOLA)-PUNTICARTE%[VC]*(PUNTICARTE%[VC]>4)*3-F
      IF CARTEUSCITE=38 AND VALORE(39)>5 THEN
            J=-F-15*(SC=BRISCOLA)-PUNTICARTE%[VC]
      END IF
      IF J<E THEN
            E=J  I=GIOCATACOMPUTER
      END IF
    END FOR
    GIOCATACOMPUTER=I
    CARTACOMPUTER
END PROCEDURE

PROCEDURE SEGNAPUNTI
    PUNTIMANO=PUNTICARTE%[VP]+PUNTICARTE%[VC]
    LOCATE(1,1)
    IF PRESA(0) THEN
          PRINT("PRENDO IO";STRING$(30,32))
          PUNTICOMPUTER=PUNTICOMPUTER+PUNTIMANO
       ELSE
          PRINT("PRENDI TU";STRING$(30,32))
          PUNTIGIOCATORE=PUNTIGIOCATORE+PUNTIMANO
    END IF
    I=CARTEUSCITE+1+PRESA(0)
    CARTEGIOCATORE[GIOCATAGIOCATORE]=CARTEUSCITE-PRESA(0)
    CARTECOMPUTER[GIOCATACOMPUTER]=I
    IF CARTEUSCITE<>40 THEN
       IF VALORE(I)=8 THEN
           TRE%[SEME(I)]=1
       END IF
       IF VALORE(I)=9 THEN
           ASSO%[SEME(I)]=1
       END IF
    END IF
    LOCATE(24,30)
    COLOR(0,7)
    PRINT("  Premi un tasto  ";)
    COLOR(7,0)
    GET(CH$)
    TURNO=1-PRESA(0)
    IF VP=9 THEN
       ASSO%[SP]=1
    END IF
    IF VC=9 THEN
       ASSO%[SC]=1
    END IF
    IF VP=8 THEN
       TRE%[SP]=1
    END IF
    IF VC=8 THEN
       TRE%[SC]=1
    END IF
END PROCEDURE

PROCEDURE PENULTIMAMANO1
! --------------------------------------
! determina la mossa alla penultima MANO
! se il computer gioca per secondo
!---------------------------------------
    LOCATE(1,1)
    PRINT("Tocca a me : io gioco  ")

    G1=GIOCATAGIOCATORE       ! g1, s1, v1  ---> var. temporanee
    S1=SP
    V1=VP

    GIOCATACOMPUTER=0         ! Parte 1  -- Caso A
    SUBC
    J=-(1+2*PRESA(0))*(PUNTICARTE%[VP]+PUNTICARTE%[VC])
    F=J
    TURNO=1-PRESA(0)
    GIOCATACOMPUTER=1         ! Parte 1  -- Caso B
    SUBC
    GIOCATAGIOCATORE=1-G1
    SUBG
    J=-(1+2*PRESA(0))*(PUNTICARTE%[VP]+PUNTICARTE%[VC])
    F=F+J
    TURNO=1
    GIOCATAGIOCATORE=G1       ! ripristina i vecchi valori
    SP=S1
    VP=V1
    GIOCATACOMPUTER=1         ! Parte 2  -- Caso A
    SUBC
    J=-(1+2*PRESA(0))*(PUNTICARTE%[VP]+PUNTICARTE%[VC])
    W=J
    TURNO=1-PRESA(0)
    GIOCATACOMPUTER=0         ! Parte 2  -- Caso B
    SUBC
    GIOCATAGIOCATORE=1-G1
    SUBG
    J=-(1+2*PRESA(0))*(PUNTICARTE%[VP]+PUNTICARTE%[VC])
    W=W+J
    GIOCATACOMPUTER=-(F<W)    ! il massimo tra Parte 1 & Parte 2
    SUBC
    GIOCATAGIOCATORE=G1       ! ripristina i valori
    SP=S1
    VP=V1
    TURNO=1
    CARTACOMPUTER
END PROCEDURE

PROCEDURE PENULTIMAMANO2
!---------------------------------------
! determina la mossa alla penultima MANO
! se il computer gioca per primo
!---------------------------------------
    LOCATE(1,1)
    PRINT("Tocca a me : io gioco  ")
    GIOCATACOMPUTER=1
    CARTACOMPUTER
END PROCEDURE

PROCEDURE ULTIMACARTA1
    CARTAGIOCATORE
    CARTACOMPUTER
END PROCEDURE

PROCEDURE ULTIMACARTA2
    CARTACOMPUTER
    CARTAGIOCATORE
END PROCEDURE

BEGIN
!-------------
! init array
!-------------
INTESTAZIONE
TURNO=CASUALE(2)+1   ! turno=1 giocatore; turno=2 computer
LOCATE(5,35)
PRINT("MAZZO A ";CHR$(70+7*TURNO);"E")
FOR I=0 TO 9     ! assegna i punti alle carte
  PUNTICARTE%[I]=ASC(MID$("00000234:;",I+1))-48
END FOR
FOR I=0 TO 39
  MAZZO%[I]=I
END FOR
FOR I=0 TO 39    ! mescola le carte
  E=CASUALE(40)
  SWAP(MAZZO%[E],MAZZO%[I]->MAZZO%[E],MAZZO%[I])
END FOR
FOR I=0 TO 2     ! assegna la prima mano
  CARTEGIOCATORE[I]=I+3
  CARTECOMPUTER[I]=I
  TRE%[SEME(I)]=-(VALORE(I)=8)
  ASSO%[SEME(I)]=-(VALORE(I)=9)
END FOR

!--------------
! inizio
!--------------
BRISCOLA=SEME(39)
D=2
FOR CARTEUSCITE=6 TO 38 STEP 2  ! loop principale
  DISEGNAGIOCATA
  CASE TURNO OF
    1-> TRECARTE END ->
    2-> GIOCACOMPUTER END ->
  END CASE
  CASE TURNO OF
    1-> RISPONDECOMPUTER END ->
    2-> TRECARTE  END ->
  END CASE
  SEGNAPUNTI
END FOR
DISEGNAGIOCATA
  CASE TURNO OF
    1-> TRECARTE END ->
    2-> GIOCACOMPUTER END ->
  END CASE
  CASE TURNO OF
    1-> RISPONDECOMPUTER END ->
    2-> TRECARTE END ->
  END CASE
SEGNAPUNTI
CARTEGIOCATORE[GIOCATAGIOCATORE]=CARTEGIOCATORE[2]
CARTECOMPUTER[GIOCATACOMPUTER]=CARTECOMPUTER[2]
D=1
DISEGNAGIOCATA
   CASE TURNO OF
      1-> DUECARTE END ->
      2-> PENULTIMAMANO2 END ->
   END CASE
   CASE TURNO OF
      1-> PENULTIMAMANO1 END ->
      2-> DUECARTE END ->
   END CASE
SEGNAPUNTI
GIOCATAGIOCATORE=1-GIOCATAGIOCATORE
GIOCATACOMPUTER=1-GIOCATACOMPUTER
CLS
IF TURNO=1 THEN
     ULTIMACARTA1
   ELSE
     ULTIMACARTA2
END IF
SEGNAPUNTI
INTESTAZIONE
MOSTRAPUNTI
!LOCATE(12,30)
!PRINT("Giochi ancora <S/N> ?")
!REPEAT
!    A$=INKEY$: IF A$="s" OR A$="S" THEN RUN
!UNTIL A$<>"n" AND A$<>"N"
LOCATE(15,30)
PRINT("Grazie di aver giocato.")
END PROGRAM
