!---------------------------------------------------------------
! PONG.R : gioca con i tasti "\" e "/" per deviare una pallina
! versione originale del 6-7-87
!---------------------------------------------------------------

PROGRAM PONG

!$KEY
!$INCLUDE="PC.LIB"

PROCEDURE SETUP
!
! inizializzazione
!
   COLOR(0,7)
   CLS
   A=1
   Y=5
   X=40
   D=2
   TY%=10
   TX%=10
   LOCATE(1,2)
   PRINT("";)
   FOR I=1 TO 76
      PRINT("";)
   END FOR
   PRINT("")
   FOR I=1 TO 22
      PRINT(" ";)
      FOR J=1 TO 76
         PRINT("";)
      END FOR
      PRINT("")
   END FOR
   PRINT(" ";)
   FOR I=1 TO 76
      PRINT("";)
   END FOR
   PRINT("";)
END PROCEDURE

PROCEDURE OSTACOLO
!
! piazza l'ostacolo
!
   CASE KY OF
    47->
      LOCATE(Y,X)
      PRINT("/")
      IF NOT (D=1 OR D=3)
        THEN
         D=D-2
      END IF
    END ->
    92->
      LOCATE(Y,X)
      PRINT("\")
      IF NOT (D=2 OR D=4)
        THEN
         D=D-2
      END IF
    END ->
   END CASE
   D=D+1
   IF D>4
     THEN
      D=D-4
   END IF
   IF D<1
     THEN
      D=D+4
   END IF
   CASE D OF
! switch di direzione
     1->
      Y=Y-1
      IF Y<2
        THEN
         Y=2
      END IF
    END ->
     2->
      X=X+1
      IF X>78
        THEN
         X=78
      END IF
    END ->
     3->
      Y=Y+1
      IF Y>23
        THEN
         Y=23
      END IF
    END ->
     4->
      X=X-1
      IF X<3
        THEN
         X=3
      END IF
    END ->
   END CASE
   LOCATE(LY,LX)
   PRINT("")
   !$RCODE="S=SCREEN(Y,X)"
   IF S=206
     THEN
      GAME%=FALSE
   END IF
   LOCATE(Y,X)
   PRINT("")
END PROCEDURE

PROCEDURE TOCCABORDO
   D=D+2
   IF D>4
     THEN
      D=D-4
   END IF
   SOUND(38,2)
END PROCEDURE

PROCEDURE NUOVOSET
   LOCATE(TY%,TX%)
   PRINT("";)
   TY%=2+20*RND(3)
   TX%=4+72*RND(4)
   COLOR(16,7)
   LOCATE(TY%,TX%)
   PRINT("";)
   TIME$="00:00:00"
   COLOR(0,7)
   LOCATE(25,60)
   PRINT(BAL;)
END PROCEDURE

PROCEDURE GIOCO
 REPEAT
   SETUP
   LOCATE(25,25)
   PRINT("SECONDI RESTANTI SUL BERSAGLIO NUM.";)
   NUOVOSET
   GAME%=TRUE
   REPEAT
      LY=Y
      LX=X
      IF D>4
        THEN
         D=D-4
      END IF
      REPEAT
         FLAG%=TRUE
         CASE D OF
           1->
            Y=Y-1
            IF Y<2
              THEN
               Y=2
            END IF
          END ->
           2->
            X=X+1
            IF X>78
              THEN
               X=78
            END IF
          END ->
           3->
            Y=Y+1
            IF Y>23
              THEN
               Y=23
            END IF
          END ->
           4->
            X=X-1
            IF X<3
              THEN
               X=3
            END IF
          END ->
         END CASE
         LOCATE(25,21)
         PRINT(RT;)
         !$RCODE="S=SCREEN(Y,X)"
         IF S=47 OR S=92
           THEN
! gestione ostacoli
            IF S=47 AND (D=1 OR D=3)
              THEN
               D=D+1
              ELSE
               IF S=92 AND (D=2 OR D=4)
                 THEN
                  D=D+1
                 ELSE
                  D=D-2
               END IF
            END IF
            SOUND(60,1)
            LOCATE(LY,LX)
            PRINT("")
            IF D>4
              THEN
               D=D-4
            END IF
            IF D<1
              THEN
               D=D+4
            END IF
         FLAG%=FALSE
      END IF
   UNTIL FLAG%
   IF S=206
     THEN
      SCORE=SCORE+1
      GAME%=FALSE
   END IF
   LOCATE(LY,LX)
   PRINT("")
   LOCATE(Y,X)
   PRINT("")
   CT=VAL(RIGHT$(TIME$,2))
   RT=TGT-CT
   IF RT<=0
     THEN
      GAME%=FALSE
   END IF
   IF X=3 OR X=78 OR Y=2 OR Y=23
     THEN
      TOCCABORDO
   END IF
! testa la tastiera
   GET(K$)
   IF K$=""
     THEN
      K$="."
   END IF
   KY=ASC(K$)
   IF KY=47 OR KY=92
     THEN
      OSTACOLO
   END IF
  UNTIL NOT GAME%
  BAL=BAL+1
 UNTIL BAL>5  ! giocati i cinque bersagli
 CLS
 IF SCORE<>5 THEN
    COLOR(23,0)
    LOCATE(5,31)
    PRINT("  HAI PERSO !!! ")
    COLOR(7,0)
    LOCATE(10,18)
    PRINT(" >>>>>  HAI GIOCATO I CINQUE BERSAGLI  <<<<< ")
    COLOR(0,7)
   ELSE
    LOCATE(5,30)
    PRINT(" CONGRATULAZIONI !!!")
    LOCATE(10,15)
    PRINT(" Hai colpito";SCORE;" bersagli usando";TGT;" secondi/bersaglio.")
 END IF
END PROCEDURE

PROCEDURE PRESENTAZIONE
!
! istruzioni iniziali
!
COLOR(7,0)
CLS
RANDOM=VAL(RIGHT$(TIME$,2))
LOCATE(5,28)
PRINT(" THE CAIO PONG-PONG GAME ")
LOCATE(6,28)
PRINT("")
COLOR(0,7)
FOR Y=10 TO 20
   LOCATE(Y,22)
   FOR I=1 TO 39
      PRINT(" ";)
   END FOR
END FOR
PRINT
Y=15
X=30
LY=14
LX=29
XX=1
YY=1
REPEAT
   LOCATE(LY,LX)
   PRINT("";)
   LOCATE(Y,X)
   PRINT("")
   LY=Y
   LX=X
   X=X+XX
   IF X>59
     THEN
      XX=-1
   END IF
   IF X<23
     THEN
      XX=1
   END IF
   Y=Y+YY
   IF Y>19
     THEN
      YY=-1
   END IF
   IF Y<11
     THEN
      YY=+1
   END IF
   COLOR(7,0)
   LOCATE(25,25)
   PRINT("Premi un tasto per le istruzioni";)
   GET(IN$)
UNTIL IN$<>""
COLOR(7,0)
CLS
LOCATE(5,10)
PRINT("Stai per giocare una specie di PONG-PONG. L'obiettivo del gioco")
PRINT("  di COLPIRE un bersaglio con una pallina quadrata, ovviamente mobile.")
PRINT(" La direzione della pallina  controllata inserendo degli ostacoli sul suo")
PRINT(" cammino. Per rendere il gioco pi interessante gli ostacoli restano sul)
PRINT(" campo. Tu puoi controllare la difficolt del gioco scegliendo la durata  ")
PRINT(" in cui il bersaglio rester fermo. Ti saranno dati CINQUE bersagli.")
PRINT
PRINT("    Gli ostacoli vengono messi con i tasti  '/' and '\' e metteranno un")
PRINT(" ostacolo nella posizione corrente della pallina.")
PRINT
PRINT(TAB(25);"Il BERSAGLIO sar  ";)
COLOR(23,0)
PRINT("";)
COLOR(7,0)
PRINT
PRINT(TAB(25);"La PALLINA   sar  ")
LOCATE(25,25)
PRINT(" Premi un tasto per giocare ";)
REPEAT
   AN$=INKEY$
UNTIL AN$<>""
! scegli il tempo di durata
CLS
BAL=1
SCORE=0
LOCATE(5,15)
PRINT(" Devi scegliere il tempo di durata del bersaglio ...")
LOCATE(8,6)
PRINT(" Se hai appena giocato il tempo  stato di";TGT;"secondi.")
PRINT
PRINT
PRINT("   QUANTI SECONDI (1-60) DESIDERI ?")
PRINT
PRINT("      5= INFALLIBILE")
PRINT("     10= ESPERTO")
PRINT("     20= MOLTO BUONO")
PRINT("     30= NORMALE")
PRINT("     50= PRINCIPIANTE")
REPEAT
   LOCATE(20,4)
   PRINT("IL TUO TEMPO (5-60) ";)
   INPUT(TGT)
UNTIL NOT (TGT<5 OR TGT>60)
END PROCEDURE

BEGIN
REPEAT
   PRESENTAZIONE
   GIOCO
   LOCATE(24,30)
   PRINT("Giochi ancora (S/N) ?")
   REPEAT
      GET(IN$)
   UNTIL IN$<>""
   IF IN$="N" OR IN$="n"
     THEN
      CLS
      LOCATE(12,25)
      PRINT("CIAO, CI SI SENTE ....")
   END IF
UNTIL IN$<>"S" AND IN$<>"s"
END PROGRAM
