!----------------------------------------------------
! TOTO.R : Sviluppo di sistemi ridotti totocalcio
!----------------------------------------------------

PROGRAM TOTOCALCIO

DIM RESULT$[13],E[10],T$[3],D[10],T[10],PP$[13],D$[2,13],STP$[13,32],NAMES$[13]

!$INCLUDE="PC.LIB"

PROCEDURE SETUP
! setta gli argomenti iniziali
   LIRE=600
! costo di una colonna
   FOR K=1 TO 10
      D[K]=1
      T[K]=1
   END FOR
   T$[1]="1"
   T$[2]="X"
   T$[3]="2"
   FLAG=FALSE
   CNT=0
END PROCEDURE

PROCEDURE GETKEY
   LOCATE(24,1)
   PRINT(SPC(20);)
   COLOR(0,7)
   PRINT("  PREMI UN TASTO  ";)
   COLOR(7,0)
   REPEAT
      GET(W$)
   UNTIL W$<>""
END PROCEDURE

PROCEDURE PRESENTAZIONE
   CLS
   PRINT("ͻ";)
   PRINT(" ";)
   PRINT("   COMPILAZIONE AUTOMATICA DEI SISTEMI RIDOTTI TOTOCALCIO  ";)
   PRINT(" ";)
   PRINT("ͼ";)
   DOWN(5)
   PRINT("Su video o su stampante ? (V/S)")
   REPEAT
      GET(W$)
   UNTIL NOT (W$<>"S" AND W$<>"V" AND W$<>"s" AND W$<>"v")
   IF W$="S" OR W$="s"
     THEN
      DEVICE$="LPT1:"
     ELSE
      DEVICE$="SCRN:"
   END IF
   NUMCOPIE=1
   DOWN(2)
   IF DEVICE$="LPT1:"
     THEN
      REPEAT
         PRINT("Numero di copie (1-8)";)
         INPUT(NUMCOPIE)
      UNTIL (NUMCOPIE>0 AND NUMCOPIE<9)
   END IF
   GETKEY
END PROCEDURE

PROCEDURE CLEARLINE
   LOCATE(22,1)
   PRINT(STRING$(80," ");)
   LOCATE(23,1)
   PRINT(STRING$(80," ");)
END PROCEDURE

PROCEDURE CORREZIONEDATI(PROC%)
   LOCATE(22,1)
   PRINT("Vuoi correggere qualcosa ?";)
   REPEAT
      GET(A$)
   UNTIL NOT (A$<>"S" AND A$<>"N" AND A$<>"s" AND A$<>"n")
   IF A$="S" OR A$="s"
     THEN
      REPEAT
         REPEAT
            CLEARLINE
            LOCATE(22,1)
            PRINT("Che dato vuoi cambiare";)
            INPUT(DATO%)
         UNTIL DATO%>0 AND DATO%<14
         CLEARLINE
         LOCATE(22,1)
         PRINT("Cosa vuoi immettere";)
         INPUT(DATO$)
         IF PROC%=1
           THEN
            NAMES$[DATO%]=LEFT$(DATO$+SPAZIO$,30)
           ELSE
            RESULT$[DATO%]=DATO$
         END IF
         CLEARLINE
         LOCATE(22,1)
         PRINT("Vuoi correggere ancora ?")
         REPEAT
            GET(A$)
         UNTIL NOT (A$<>"S" AND A$<>"N" AND A$<>"s" AND A$<>"n")
      UNTIL NOT (A$<>"N" AND A$<>"n")
   END IF
   CLEARLINE
END PROCEDURE

PROCEDURE CHECKERROR(AA$,OK%->OK%)
   FOR J=1 TO LEN(AA$)
      E[J]=ASC(MID$(AA$,J,1)+CHR$(0))
      IF E[J]<>49 AND E[J]<>50 AND E[J]<>88
        THEN
         OK%=FALSE
         EXIT
      END IF
   END FOR
   IF OK%
     THEN
      CASE LEN(AA$) OF
       1->
       END ->
       2->
         IF E[1]=E[2]
           THEN
            OK%=FALSE
         END IF
       END ->
       3->
         IF E[1]=E[2] OR E[2]=E[3] OR E[1]=E[3]
           THEN
            OK%=FALSE
         END IF
       END ->
       OTHERWISE
         OK%=FALSE
      END CASE
   END IF
END PROCEDURE

PROCEDURE GETNAME
   CLS
   PRINT("Introduci le partite : ")
   PRINT(STRING$(80,"");)
   DOWN(1)
   FOR II=1 TO 13
      PRINT("Incontro n";II;)
      INPUT(NAMES$[II])
      SPAZIO$="                              "
      NAMES$[II]=LEFT$(NAMES$[II]+SPAZIO$,30)
      IF II=3 OR II=6 OR II=9
        THEN
         PRINT(STRING$(80,"");)
      END IF
   END FOR
   CORREZIONEDATI(1)
   GETKEY
END PROCEDURE

PROCEDURE INGRESSODATI
   CLS
   PRINT("Introduci il tuo pronostico : ")
   PRINT(STRING$(80,"");)
   DOWN(1)
   FOR K=1 TO 13
      PRINT(RIGHT$(STR$(K),2);" incontro";)
      INPUT(RESULT$[K])
      CHECKERROR(RESULT$[K],TRUE->OK%)
      IF NOT OK%
        THEN
         UP(1)
         K=K-1
        ELSE
         CASE LEN(RESULT$[K]) OF
          1->
            FISSE=FISSE+1
          END ->
          2->
            DOPPIE=DOPPIE+1
          END ->
          3->
            TRIPLE=TRIPLE+1
          END ->
         END CASE
         IF K=3 OR K=6 OR K=9
           THEN
            PRINT(STRING$(80,"");)
         END IF
      END IF
   END FOR
   CORREZIONEDATI(2)
   GETKEY
END PROCEDURE

PROCEDURE COMMENTODATI(OK%->OK%)
   CLS
   SCOMP=INT(3^TRIPLE*2^DOPPIE)
   PRINT("Ci sono";FISSE;" fisse,";DOPPIE;" doppie e";TRIPLE;"triple .")
   PRINT("Lo sviluppo del sistema completo richiederebbe";SCOMP;" colonne,")
   PRINT("pari ad una spesa di";SCOMP*LIRE;" lire.")
   CASE TRIPLE OF
    0->
      IF DOPPIE<7
        THEN
         OK%=FALSE
        ELSE
         SRIDOT=INT(16*2^(DOPPIE-7))
      END IF
    END ->
    1->
      IF DOPPIE<7
        THEN
         OK%=FALSE
        ELSE
         SRIDOT=INT(48*2^(DOPPIE-7))
      END IF
    END ->
    2->
      IF DOPPIE<7
        THEN
         OK%=FALSE
        ELSE
         SRIDOT=INT(144*2^(DOPPIE-7))
      END IF
    END ->
    3->
      SRIDOT=INT(5*2^DOPPIE)
    END ->
    OTHERWISE
      SRIDOT=INT(3^(TRIPLE-2)*2^DOPPIE)
   END CASE
   IF OK%
     THEN
      PRINT("Mentre invece con il sistema ridotto che ti elaborer lo sviluppo si")
      PRINT("riduce a solo";SRIDOT;" colonne, pari ad una spesa di";SRIDOT*LIRE;" lire.")
      PRINT("Il rapporto di riduzione e'";INT(SCOMP/SRIDOT+0.5);" e risparmierai")
      PRINT("mantenendo la certezza di realizzare almeno un dodici e la probabilit")
      PRINT("(ca. il";INT(1/INT(SCOMP/SRIDOT+0.5)*1000+0.1)/10;"%) di fare anche un tredici.")
      DOWN(1)
      PRINT("Bisognera' riempire";INT(SRIDOT/4+0.9);" schedine.")
   END IF
   GETKEY
END PROCEDURE

PROCEDURE SETTEDOPPIE
   REPEAT
      IF ND=1
        THEN
         READ(D$)
      END IF
   UNTIL LEN(D$)=7
   Q$=MID$(D$,ND,1)
   IF D$[1,J]="1" AND D$[2,J]="X"
     THEN
      PP$[J]=Q$
     ELSE
      IF D$[1,J]="X" AND D$[2,J]="1"
        THEN
         PP$[J]=Q$
        ELSE
         IF D$[1,J]="2" AND D$[2,J]="1" AND Q$="1"
           THEN
            PP$[J]=Q$
           ELSE
            IF D$[1,J]="1" AND D$[2,J]="2" AND Q$="1"
              THEN
               PP$[J]=Q$
              ELSE
               IF D$[1,J]="2" AND D$[2,J]="1" AND Q$="X"
                 THEN
                  PP$[J]="2"
                 ELSE
                  IF D$[1,J]="1" AND D$[2,J]="2" AND Q$="X"
                    THEN
                     PP$[J]="2"
                    ELSE
                     IF D$[1,J]="X" AND D$[2,J]="2" AND Q$="1"
                       THEN
                        PP$[J]="2"
                       ELSE
                        IF D$[1,J]="2" AND D$[2,J]="X" AND Q$="1"
                          THEN
                           PP$[J]="2"
                          ELSE
                           PP$[J]=Q$
                        END IF
                     END IF
                  END IF
               END IF
            END IF
         END IF
      END IF
   END IF
END PROCEDURE

PROCEDURE DOPPIEINTEGRALI
   DD=DD+1
   IF NOT FLAG
     THEN
      DM=INT(16*3^TRIPLE)
     ELSE
      IF T=3
        THEN
         DM=5
        ELSE
         DM=INT(3^(TRIPLE-2))
      END IF
   END IF
   D[0]=D[0]+1
   IF NOT (D[0]<=DM*(DOPPIE-7) AND NOT FLAG)
     THEN
      IF NOT (D[0]<=DM*DOPPIE AND FLAG)
        THEN
         D[0]=1
         D[1]=D[1]+1
         FOR W=0 TO 10
            IF D[W]>2
              THEN
               D[W]=1
               D[W+1]=D[W+1]+1
            END IF
         END FOR
      END IF
   END IF
   PP$[J]=D$[D[DD],J]
END PROCEDURE

PROCEDURE TRETRIPLE
   NT=NT+1
   REPEAT
      IF NT=1
        THEN
         READ(T$)
      END IF
      IF LEN(T$)>3
        THEN
         RESTORE
      END IF
   UNTIL LEN(T$)<=3
   QQ$=MID$(T$,NT,1)
   PP$[J]=QQ$
END PROCEDURE

PROCEDURE QUATTROTRIPLE
   REPEAT
      REPEAT
         IF NT=1
           THEN
            READ(T$)
         END IF
      UNTIL LEN(T$)>=4
      IF LEN(T$)>4
        THEN
         RESTORE
      END IF
   UNTIL LEN(T$)<=4
   Z$=MID$(T$,NT,1)
   PP$[J]=Z$
END PROCEDURE

PROCEDURE TRIPLEINTEGRALI
   TT=TT+1
   IF NOT FLAG
     THEN
      TM=16
     ELSE
      IF TRIPLE>3
        THEN
         TM=9
      END IF
   END IF
   T[0]=T[0]+1
   IF NOT (T[0]<=TM*(TRIPLE-4) AND TRIPLE>3)
     THEN
      IF NOT (T[0]<=TM*TRIPLE AND TRIPLE<3)
        THEN
         T[0]=1
         T[1]=T[1]+1
         FOR W=0 TO 10
            IF T[W]>3
              THEN
               T[W]=1
               T[W+1]=T[W+1]+1
            END IF
         END FOR
      END IF
   END IF
   PP$[J]=T$[T[TT]]
END PROCEDURE

PROCEDURE RIEMPIMENTO
   FOR K=1 TO 13
      IF LEN(RESULT$[K])=2
        THEN
         D$[1,K]=LEFT$(RESULT$[K],1)
         D$[2,K]=RIGHT$(RESULT$[K],1)
      END IF
   END FOR
END PROCEDURE

PROCEDURE STAMPACOLONNA
   FOR JJ=1 TO 13
      STP$[JJ,COL-32*CNT]=PP$[JJ]
   END FOR
   IF COL=SRIDOT OR FRC(COL/32)=0
     THEN
      FOR X=1 TO NUMCOPIE
         OPEN("O",1,DEVICE$)
         FOR II=1 TO 13
            PRINT(#1,NAMES$[II];RIGHT$("  "+RESULT$[II],3);"  ";)
            JJ=1
            WHILE JJ<=SRIDOT-32*CNT AND JJ<=32
               PRINT(#1,STP$[II,JJ];)
               IF FRC(JJ/4)=0
                 THEN
                  PRINT(#1," ";)
               END IF
               JJ=JJ+1
            END WHILE
            PRINT(#1,)
         END FOR
         PRINT(#1,)
         PRINT(#1,)
         CLOSE(1)
      END FOR
      CNT=CNT+1
   END IF
END PROCEDURE

PROCEDURE ELABORATOTO
   IF DOPPIE>0
     THEN
      RIEMPIMENTO
      IF TRIPLE>2
        THEN
         FLAG=TRUE
      END IF
      FOR COL=1 TO SRIDOT
         P$=""
         FOR J=1 TO 13
            IF LEN(RESULT$[J])=1
              THEN
               PP$[J]=RESULT$[J]
              ELSE
               IF LEN(RESULT$[J])=2 AND TRIPLE<3
                 THEN
                  IF FLAG
                    THEN
                     DOPPIEINTEGRALI
                    ELSE
                     ND=ND+1
                     IF ND>7
                       THEN
                        DD=ND-7
                        DD=DD-1
                        DOPPIEINTEGRALI
                       ELSE
                        SETTEDOPPIE
                     END IF
                  END IF
                 ELSE
                  IF LEN(RESULT$[J])=2
                    THEN
                     DOPPIEINTEGRALI
                    ELSE
                     IF TRIPLE<3
                       THEN
                        TRIPLEINTEGRALI
                       ELSE
                        IF TRIPLE=3
                          THEN
                           TRETRIPLE
                          ELSE
                           NT=NT+1
                           IF NT>4
                             THEN
                              TT=NT-4
                              TT=TT-1
                              TRIPLEINTEGRALI
                             ELSE
                              QUATTROTRIPLE
                           END IF
                        END IF
                     END IF
                  END IF
               END IF
            END IF
            P$=P$+PP$[J]
         END FOR
         IF D$="XXXXXXX"
           THEN
            RESTORE
         END IF
         ND=0
         NT=0
         DD=0
         TT=0
         STAMPACOLONNA
         IF COL=SRIDOT
           THEN
            PRINT
            EXIT
         END IF
      END FOR
   END IF
END PROCEDURE

BEGIN
   DATA("X21","21X","2X2","112","1XX")
   DATA("1111","XXX1","2221","1X21","X21X")
   DATA("1111111","1X11XX1","11X1X1X","1XX11XX")
   DATA("111X1XX","1X1XX1X")
   DATA("11XXXX1","1XXX111","X111XXX")
   DATA("XX1111X","X1X11X1","XXX1X11")
   DATA("X11XX11","XX1X1X1","X1XX11X")
   DATA("XXXXXXX")
   SETUP
   PRESENTAZIONE
   GETNAME
   INGRESSODATI
   COMMENTODATI(TRUE->OK%)
   IF OK%
     THEN
      CLS
      ELABORATOTO
     ELSE
      CLS
      PRINT("Non posso elaborare : troppe poche colonne per il mio ridotto.")
   END IF
END PROGRAM
