!-------------------------------------------------
! DOTS.R : gioco contro il PC (vedi spiegazioni)
!-------------------------------------------------

PROGRAM PCDOTS

!$KEY

!$SEGMENT=&HB800

DIM LC%[80],VH%[80],RT%[16],RM%[9],CM%[9],BL$[6],BM$[6],BR$[6]

FUNCTION ODD(X)
   ODD=(FRC(X/2)<>0)
END FUNCTION

PROCEDURE CLS
   PRINT(CHR$(12);)
END PROCEDURE

PROCEDURE WAITONOPERATOR
   PRINT("Premi INVIO per continuare.")
   REPEAT
     GET(CH$)
   UNTIL CH$=CHR$($0D)
END PROCEDURE

PROCEDURE GIVEINSTRUCT
   PRINT("                        -----    DOTS    -----")
   PRINT
   PRINT("   Gioca l'antico gioco del DOTS.")
   PRINT
   PRINT("Vuoi le istruzioni (S/N)";)
   INPUT(CH$)
   IF CH$="s" OR CH$="S"
     THEN
       CLS
       PRINT("               -----   DOTS  -----")
       PRINT
       PRINT
       PRINT(" Gioca a dots contro il PC - devi tentare di catturare i quadra-")
       PRINT(" ti completando il quarto lato. Naturalemnte devi evitare di ")
       PRINT(" creare quadrati da tre lati, che il PC catturebbe.")
       PRINT
       PRINT(" Muovi il cursore usando i tasti sottoelencati. Quando il curso-")
       PRINT(" sore  dove desideri per tracciare un lato premi <RETURN>.")
       PRINT
       PRINT(" Il cursore  controllato dai seguenti tasti:")
       PRINT
       PRINT(" S -> muove a sinistra           F -> muove a destra")
       PRINT(" E -> muove in alto              C -> muove in basso")
       PRINT(" V -> muove in basso e destra    X -> move basso e sinistra")
       PRINT(" R -> muove in alto e destra     W -> move alto e sinistra")
       PRINT
       PRINT(" Devi premere  RETURN  per effettuare la tua mossa.")
       PRINT
       WAITONOPERATOR
     ELSE
   END IF
END PROCEDURE

PROCEDURE INITCONSTARRAYS
   DATA(3,4,2,6,4,5,1,7,2,1,0,8,6,7,8,9,1,2,1,0,0,0,-1,-2,-1,-1,0,1,-2,0,2,-1,0,1)
   FOR INDICE%=0 TO 15
     READ(RT%[INDICE%])
   END FOR
   FOR INDICE%=1 TO 9
     READ(RM%[INDICE%])
   END FOR
   FOR INDICE%=1 TO 9
     READ(CM%[INDICE%])
   END FOR
END PROCEDURE

PROCEDURE POSITCURS(X%,Y%)
!$R="LOCATE X%+RF%,Y%+CF%"
END PROCEDURE

PROCEDURE SHOWPLAYAREA
   CLS
   PRINT("        <<<<<   D O T S   >>>>";)
   FOR RR%=0 TO RS%
     POSITCURS(RR%*2,0)
     PRINT(BL$[RR%];" ";)
     FOR CC%=1 TO CS%-1
       PRINT(BM$[RR%];" ";)
     END FOR
     PRINT(BR$[RR%];" ")
   END FOR
END PROCEDURE

PROCEDURE HUMANMOVE(->FLAG%)
   FLAG%=FALSE%
   RR%=HR%
   CC%=HC%
   MOVED%=TRUE
   REPEAT
     REPEAT
       IF MOVED%
         THEN
           POSITCURS(RR%,CC%)
           EXISTING$=CHR$(PEEK(2*SCREENWIDTH%*(RR%+RF%-1)+2*(CC%+CF%-1)))
           MOVED%=FALSE
         ELSE
       END IF
       REPEAT
         IF ODD(CC%)
           THEN
             PRINT("";)
           ELSE
             PRINT("";)
         END IF
         FOR II%=1 TO 0
         END FOR
         PRINT(CHR$(29);EXISTING$;CHR$(29);)
         GET(CH$)
       UNTIL CH$<>""
       IF CH$=" "
         THEN
           FLAG%=TRUE
         ELSE
       END IF
       IF NOT FLAG%
         THEN
           CASE CH$ OF
             "W","w"->  CH$="7"  END ->
             "E","e"->  CH$="8"  END ->
             "R","r"->  CH$="9"  END ->
             "S","s"->  CH$="4"  END ->
             "F","f"->  CH$="6"  END ->
             "V","v"->  CH$="3"  END ->
             "C","c"->  CH$="2"  END ->
             "X","x"->  CH$="1"  END ->
             OTHERWISE
           END CASE
           IF (CH$>="1") AND (CH$<="9")
             THEN
               INDEX%=ASC(CH$)-ASC("0")
               RMOVE%=RM%[INDEX%]
               CMOVE%=CM%[INDEX%]
               RR%=RR%+RMOVE%
               CC%=CC%+CMOVE%
               MOVED%=TRUE
               IF (RR%<0) OR (CC%<0) OR (RR%>2*RS%) OR (CC%>2*CS%)
                 THEN
                   RR%=RR%-RMOVE%
                   CC%=CC%-CMOVE%
                   MOVED%=FALSE
                 ELSE
               END IF
           END IF
       END IF
     UNTIL CH$=CHR$($0D) OR FLAG%
     IF NOT FLAG%
       THEN
         ROW%=INT(RR%/2)+1
         CL%=INT(CC%/2)+1
         V%=ODD(RR%)
         H%=NOT V%
         IF V%
           THEN
             DIRECTION%=VERTICAL%
           ELSE
             DIRECTION%=HORIZONTAL%
         END IF
       ELSE
     END IF
   UNTIL (VH%[ROW%+CL%*9] AND (-VERTICAL%*V%-HORIZONTAL%*H%))=0 OR FLAG%
   IF NOT FLAG%
     THEN
       HR%=RR%
       HC%=CC%
       FLAG%=FALSE
     ELSE
   END IF
END PROCEDURE

PROCEDURE SETNEWMAX(DR%)
   DIRECTION%=DR%
   MAXIMUM%=F%
   ROW%=II%
   CL%=JJ%
END PROCEDURE

PROCEDURE COMPMOVE
   MAXIMUM%=-1
   FOR II%=1 TO RS%
     FOR JJ%=1 TO CS%+1
       IF (VH%[II%+9*JJ%] AND VERTICAL%)=0
         THEN
           F%=RT%[LC%[II%+9*(JJ%-1)]+4*LC%[II%+JJ%*9]]
           IF F%>MAXIMUM%
             THEN
               SETNEWMAX(VERTICAL%)
             ELSE
               IF F%=MAXIMUM%
                 THEN
                   IF RND(1)<0.5
                     THEN
                       SETNEWMAX(VERTICAL%)
                     ELSE
                   END IF
                 ELSE
               END IF
           END IF
         ELSE
       END IF
     END FOR
   END FOR
   FOR II%=1 TO RS%+1
     FOR JJ%=1 TO CS%
       IF (VH%[II%+9*JJ%] AND HORIZONTAL%)=0
         THEN
           F%=RT%[LC%[II%-1+9*JJ%]+4*LC%[II%+JJ%*9]]
           IF F%>MAXIMUM%
             THEN
               SETNEWMAX(HORIZONTAL%)
             ELSE
               IF F%=MAXIMUM%
                 THEN
                   IF RND(1)<0.5
                     THEN
                       SETNEWMAX(HORIZONTAL%)
                     ELSE
                   END IF
                 ELSE
               END IF
           END IF
         ELSE
       END IF
     END FOR
   END FOR
END PROCEDURE

PROCEDURE SL5500
   LC%[ROW%+CL%*9]=LC%[ROW%+CL%*9]+1
   IF DIRECTION%=HORIZONTAL%
     THEN
       LC%[ROW%-1+9*CL%]=LC%[ROW%-1+9*CL%]+1
       TEMP%=HORIZONTAL%
     ELSE
       LC%[ROW%+9*(CL%-1)]=LC%[ROW%+9*(CL%-1)]+1
       TEMP%=VERTICAL%
   END IF
   VH%[ROW%+9*CL%]=VH%[ROW%+9*CL%] OR TEMP%
END PROCEDURE

PROCEDURE SHOWMOVE
   POSITCURS(2*(ROW%-1),2*(CL%-1))
   IF DIRECTION%=HORIZONTAL%
     THEN
       MOVE$=CHR$(28)
       BAR$=""
     ELSE
       MOVE$=CHR$(31)
       BAR$=""
   END IF
   PRINT(MOVE$;BAR$;)
   IF PLAYER%=2
     THEN
       FOR II%=1 TO 7
         FOR JJ%=1 TO DELAY%
         END FOR
         PRINT(CHR$(29);" ";)
         FOR JJ%=1 TO DELAY%
         END FOR
         PRINT(CHR$(29);BAR$;)
       END FOR
     ELSE
   END IF
END PROCEDURE

PROCEDURE SL5900(RR%,CC%)
   SUBS%=RR%+CC%*9
   IF NOT ((LC%[SUBS%]<>4) OR (VH%[SUBS%] AND 12)>0)
     THEN
       VH%[SUBS%]=VH%[SUBS%] OR PLAYER%*12
       TOTAL%=TOTAL%+1
       POSITCURS(RR%*2-1,CC%*2-1)
       SQUARESLEFT%=SQUARESLEFT%-1
       IF PLAYER%=1
         THEN
           PRINT("+";)
           HUMANCOUNT%=HUMANCOUNT%+1
         ELSE
           PRINT("-";)
           COMPCOUNT%=COMPCOUNT%+1
       END IF
     ELSE
   END IF
END PROCEDURE

PROCEDURE SL5800(->SL%)
   TOTAL%=0
   SL5900(ROW%,CL%)
   SL5900(ROW%-1,CL%)
   SL5900(ROW%,CL%-1)
   SL%=TOTAL%
END PROCEDURE

BEGIN
  RS%=6
  CS%=6
  HORIZONTAL%=1
  VERTICAL%=2
  DELAY%=50
  SCREENWIDTH%=40
  GIVEINSTRUCT
  RF%=11-RS%
  CF%=19-CS%
  INITCONSTARRAYS
  BL$[0]=""
  BM$[0]=""
  BR$[0]=""
  FOR R%=1 TO RS%-1
    BL$[R%]=""
    BM$[R%]=""
    BR$[R%]=""
  END FOR
  BL$[RS%]=""
  BM$[RS%]=""
  BR$[RS%]=""
  !$R="WIDTH 40"
  REPEAT
    SHOWPLAYAREA
    FOR I%=0 TO 8
      FOR J%=0 TO 8
        SUBS%=I%+9*J%
        LC%[SUBS%]=0
        VH%[SUBS%]=0
      END FOR
    END FOR
    HUMANCOUNT%=0
    COMPCOUNT%=0
    SQUARESLEFT%=RS%*CS%
    PLAYER%=1
    HR%=0
    HC%=1
    QUIT%=FALSE
    WHILE SQUARESLEFT%>0 AND NOT QUIT%
      IF PLAYER%=1
        THEN
          HUMANMOVE(->QUIT%)
        ELSE
          COMPMOVE
      END IF
      IF NOT QUIT%
        THEN
          SL5500
          SHOWMOVE
          SL5800(->SL%)
          IF SL%=0
            THEN
              PLAYER%=3-PLAYER%
            ELSE
          END IF
        ELSE
      END IF
    END WHILE
    IF QUIT%
      THEN
        PRINT(CHR$(13);"Spiacente, hai deciso di rinunciare")
      ELSE
        IF HUMANCOUNT%>COMPCOUNT%
          THEN
            PRINT(CHR$(13);"Vinci con";HUMANCOUNT%;" quadrati contro i miei";COMPCOUNT%)
          ELSE
            IF HUMANCOUNT%=COMPCOUNT%
              THEN
                PRINT(CHR$(13);"Pareeggiamo con";HUMANCOUNT%;" quadrati ciascuno")
              ELSE
                PRINT(CHR$(13);"Vinco, con";COMPCOUNT%;" quadrati contro i tuoi";HUMANCOUNT%)
            END IF
        END IF
    END IF
    PRINT("Vuoi giocare ancora (S/N)";)
    INPUT(CH$)
  UNTIL CH$<>"S" AND CH$<>"s"
  !$R="WIDTH 80"
END PROGRAM
